/*--- VDP.C -------------------------------------------------------------------
function: Graphic functions library for use with MUNU
credits:  FVu, Dec-1998 (freddy@textinfo.nl)
*/

#include <stdio.h>
#include <glib.h>
#include "wwdb.h"
#include "wlib.h"
#include "mmi.h"
#include "vdp.h"
#include "vdpm.h"

#define  LINL40 	(*(char *)0xF3AE)
#define  TXTNAM 	(*(int *)0xF3B3)
#define  TXTCGP 	(*(int *)0xF3B7)
#define  CGPBAS 	(*(int *)0xF924)


/*---------------------------------------------------------------- variables */
SCOLOR	bcolor; 			/* Color backup */
TINY	bFORCLR, bBAKCLR, bBDRCLR;
					/* Menu colors */
SCOLOR	mcolor = {0x0777, 0x0000, 0x777, 0x007};

char	VRAMPG;
						/* TIME */
char TimeOd[] = "00:00:00";
char TimeNw[] = "00:00:00";
char TimeOn = YES;
int  TimePs = 72;



/*---------------------------------------------------------------- functions */
VOID InstCol(color)
SCOLOR *color;
{
   setplt((TINY) 15, color->PLT1);
   setplt((TINY) 1, color->PLT2);
   setplt((TINY) 2, color->PLT3);
   setplt((TINY) 3, color->PLT4);
}


VOID VDPEnd() {
   filvrm(0x800, 240, (char) 0);
   InstCol(&bcolor);
   color(bFORCLR, bBAKCLR, bBDRCLR);
   wrtvdp((TINY) 4, (char) 2);		       /* TXTCGP = 0x1000 */
}


VOID VDPInit() {
   VRAMPG =0;
   LINL40 = WIDTH;
   ChgMod((char) 0);
   wrtvdp((TINY) 4, (char) 6);		       /* TXTCGP = 0x3000 */

   filvrm(0x800, 240, (char) 0);	/* Reset blinks */
   wrtvdp((TINY) 13, 0xF0);		/* Blinks on */
   wrtvdp((TINY)  7, 0xF1);		/* Text color numbers */
   wrtvdp((TINY) 12, 0x23);		/* Blink color numbers */

   bcolor.PLT1 = getplt((TINY) 15);	/* Backup existing colors */
   bcolor.PLT2 = getplt((TINY) 1);
   bcolor.PLT3 = getplt((TINY) 2);
   bcolor.PLT4 = getplt((TINY) 3);
   bFORCLR = c_fore;
   bBAKCLR = c_back;
   bBDRCLR = c_bord;

   InstCol(&mcolor);

   ldirmv(HP, 0x1000, 2048);		     /* Copy default font */
   ldirvm(0x3000, HP, 2048);

   ldirmv(HP, 0x1208, 464);		     /* Make underlined ASCII */
   lnText = HP - 1;
   for (ci = 0; ci++ < 58;)
      *lnText = *(lnText+=8) ^ 0xF8;
   ldirvm(0x3608, HP, 464);

   ldirmv(HP, 0x1208, 464);		     /* Make inverse ASCII */
   for (ii = 0; ii++ < 464;)
      *lnText = ~(*(++lnText));
   ldirvm(0x3408, HP, 464);
}


VOID TimePrint() {
   if (TimeOn) {
      for (ci=0, cj=7; ci !=6; ci++, cj--) {
	 if (cj == 5 || cj == 2)				/* skip ':' */
	    cj--;
	 TimeNw[cj] = RdClck(ci) + '0';
      }
      if (strcmp(TimeOd, TimeNw))
	 ldirvm(TimePs, strcpy(TimeOd, TimeNw), 8);	    /* copy to VRAM */
   }
}

