/*--- WWDB.C ------------------------------------------------------------------
function: Window Data Base.  This file contains the window definitions.
credits:  FVu, Dec-1998 (freddy@textinfo.nl)
*/

#include <stdio.h>
#include "vdp.h"
#include "mmi.h"
#include "wwdb.h"
#include "wlib.h"
#include "neu.h"


WWLINE	wwYLin[]  = {
   {"Yes", 'Y', _ACFNC, NULL, 242, 244},
   {"No",  'N', _ACFNC, NULL, 246, 247},
   {""}
};
WWINFO	wwY	  = {0xF5, 0, 0, 0, wwYLin, NULL, 1, 2};

WWLINE	ww9Lin[]  = {
   {"Standard",   'S', 0x00,   NULL},
   {"Load",       'L', 0x00,   NULL},
   {"Save",       'S', 0x00,   NULL},
   {"Edit",       'E', 0x00,   NULL},
   {"",            0,  _ACOFF, NULL},
   {"Underline",  'U', 0x00,   NULL},
   {"Inverse",    'I', 0x00,   NULL},
   {"Menu keys",  'M', 0x00,   NULL}
};
WWINFO	ww9	 = {0x2B, 0, 13, 10, ww9Lin, &ww1, 0, 8};

WWLINE ww1Lin[]  = {
   {"About..",         'A', 0x00,   NULL},
   {"Control",          0,  0x00,   NULL},
   {"Color",            0,  0x00,   NULL},
   {"Character set",   'C', _ACOWW, (char *) &ww9},
   {"",                 0,  _ACOFF, NULL},
   {"Shell MSX-DOS",    0,  0x00,   NULL},
   {"Shell MSX-BASIC",  0,  0x00,   NULL},
   {"",                 0,  _ACOFF, NULL},
   {"MSX-DOS      ^X",  0,  _ACFNC, (char *) EndMnu},
   {"MSX-BASIC",        0,  0x00, NULL}
};
WWINFO	ww1	  = {0x2B, 0, 19, 12, ww1Lin, &ww0, 0, 10};

WWLINE ww2Lin[]  = {
   {"Silo 1", 0, 0x00,   NULL},
   {"Silo 2", 0, 0x00,   NULL},
   {"",       0,   _ACOFF, NULL},
   {"Silo 3", 0, 0x00,   NULL},
   {"Silo 4", 0, 0x00,   NULL}
};
WWINFO	ww2	  = {0x2B, 0, 10, 7, ww2Lin, &ww0, 0, 5};

WWLINE	ww3Lin[]  = {
	{"Actions",     'G', 0x01, (char *) &ww5},
	{"Colors", 'O', 0x01, (char *) &ww6}
};
WWINFO	ww3	  = {0x2B, 0, 12, 4, ww3Lin, &ww0, 0, 2};

WWLINE	ww4Lin[]  = {
   {"Amiga 500",     0, _ACOFF, NULL},
   {"Amiga 500+",    0, 0x00,   NULL},
   {"Amiga 1000",    0, _ACOFF, NULL},
   {"Amiga 2000",    0, 0x00,   NULL},
   {"Amiga 3000",    0, 0x00,   NULL},
   {"Amiga 4000/30", 0, _ACOFF, NULL},
   {"Amiga 4000/40", 0, _ACOFF, NULL}
};
WWINFO	ww4	  = {0x2B, 0, 17, 9, ww4Lin, &ww0, 1, 7};

WWLINE	ww5Lin[]  = {
	{"Sun", 'S', 0x00, NULL},
	{"Rain", 'R', 0x00, NULL},
	{"Wind", 'W', 0x00, NULL},
	{"Cycling", 'C', 0x00, NULL}
};
WWINFO	ww5	  = {0x2B, 0, 11, 6, ww5Lin, &ww3, 0, 4};

WWLINE	ww6Lin[]  = {
	{"Red",   'R', 0x00, NULL},
	{"Green",     'G', 0x00, NULL},
	{"Blue",    'B', 0x00, NULL},
	{"Yellow", 'Y', 0x00, NULL}
};
WWINFO	ww6	  = {0x2B, 0, 12, 6, ww6Lin, &ww3, 0, 4};

WWLINE	ww7Lin[]  = {
   {"Marlies",  'L', 0x00, NULL},
   {"Saskia",   'S', 0x00, NULL},
   {"Ellen",    'E', 0x00, NULL},
   {"Miranda",  'N', 0x00, NULL},
   {"Angeline", 'A', 0x00, NULL},
   {"Carola",   'C', 0x00, NULL},
   {"Conny",    'Y', 0x00, NULL},
   {"",          0,  _ACOFF, NULL},
   {"Joyce",    'J', 0x00, NULL},
   {"Monique",  'Q', 0x00, NULL},
   {"Ilse",     'I', 0x00, NULL},
   {"Marianne", 'R', 0x00, NULL},
   {"Inge",     'G', 0x00, NULL},
   {"Marion",   'M', 0x00, NULL},
   {"Tineke",   'T', 0x00, NULL}
};
WWINFO	ww7	  = {0x2F, 0, 12, 17, ww7Lin, &ww0, 0, 15};

WWLINE	ww8Lin[]  = {
	{"Swim", 'S', 0x00, NULL},
   {"School",  'S', _ACFNC, (char *) SchoolsOut},
};
WWINFO	ww8	  = {0x2B, 0, 11, 4, ww8Lin, &ww0, 0, 2};


WWLINE	ww0Lin[]  = {
	{"Munu",   'M', _ACOWW, (char *) &ww1, 0, 3},
	{"Farm",   'K', _ACOWW, (char *) &ww2, 5, 8},
	{"Things",  'T', _ACOWW, (char *) &ww3, 10, 15},
	{"Commodore",    'C', _ACOWW, (char *) &ww4, 17, 25},
	{"Freddy", 'F', _ACOWW, (char *) &ww7, 27, 32},
	{"Recreation", 'R', _ACOWW, (char *) &ww8, 34, 43}
};
WWINFO	ww0	  = {0x24, 0, WIDTH, 1, ww0Lin, NULL, 0, 6};


WWINFO	*wwAll[] = {&ww0, &ww1, &ww2, &ww3, &ww4, &ww5, &ww6, &ww7, &ww8, &ww9,
		    &wwY, NULL};


VOID SetMkey(KeySet)
char  KeySet;
{
   ci = 0;					/* window counter */
   ii = (int) ActWW;				/* backup ActWW */
   while (ActWW = wwAll[ci++]) {
      Fillwwvar();
      wwCpos = -1;			/* first increase cause wwCpos is */
      while (++wwCpos < wwNrOpts) {	/* used in 'Filllnvar()' */
	 Filllnvar();
	 lnText--;
	 while (*(++lnText)) {
	    if (toupper((*lnText ^ bKeySet) + 0x40) == lnKey) {
	       *lnText = (*lnText ^ bKeySet) + KeySet;
	       break;
	    }
	 }
      }
   }
   bKeySet = KeySet;
   ActWW = (WWINFO *) ii;			/* Restore ActWW */
   Fillwwvar(); 			/* restore easy window variables */
   Filllnvar();
}
